/** Rechte.java
 *
 * simuliert die Rechteberechnung bei gesetzter umask in UNIX:
 * bitweise UND-Verknuepfung von Grundwert und negierter umask
 */


import java.io.*;

class Rechte {

   public static void main(String[] args) throws Exception {

	InputStreamReader ipr = new InputStreamReader(System.in);
	BufferedReader keyboard = new BufferedReader(ipr);	

	int grundWert, umask, rechte;
	String type;

	// Grundwert einstellen
	grundWert = 0666; 	// Oktalzahl

	System.out.print("Wollen Sie Rechte für ein Verzeichnis berechnen? ('j/n')? ");
	type = keyboard.readLine();

 	if (type.equals("j"))		//Strings vergleichen
		grundWert = 0777;	// Oktalzahl

	System.out.print("Geben Sie Wert von umask ein!  ");
	umask = Integer.parseInt(keyboard.readLine(),8);   // als Oktalzahl

	// Rechte berechnen
	rechte = grundWert & (~umask);

  	// Ausgabe
	System.out.println("Ihre Rechte: " + Integer.toOctalString(rechte));
   }
}
